diff -uNr rbovirt-0.0.15-old/lib/client/quota_api.rb rbovirt-0.0.15/lib/client/quota_api.rb
--- rbovirt-0.0.15-old/lib/client/quota_api.rb	1969-12-31 19:00:00.000000000 -0500
+++ rbovirt-0.0.15/lib/client/quota_api.rb	2013-03-08 08:49:32.853000035 -0500
@@ -0,0 +1,14 @@
+module OVIRT
+  class Client
+    def quota(quota_id, opts={})
+      q = http_get("/datacenters/%s/quotas/%s" % current_datacenter.id % quota_id)
+      OVIRT::Quota::new(self, q.root)
+    end
+
+    def quotas(opts={})
+      http_get("/datacenters/%s/quotas" % CGI.escape(current_datacenter.id)).xpath('/quotas/quota').collect do |q|
+        OVIRT::Quota::new(self, q)
+      end.compact
+    end
+  end
+end
diff -uNr rbovirt-0.0.15-old/lib/client/template_api.rb rbovirt-0.0.15/lib/client/template_api.rb
--- rbovirt-0.0.15-old/lib/client/template_api.rb	2012-12-12 17:57:36.000000000 -0500
+++ rbovirt-0.0.15/lib/client/template_api.rb	2013-03-08 07:42:06.987992454 -0500
@@ -34,4 +34,4 @@
       end
     end
   end
-end
\ No newline at end of file
+end
diff -uNr rbovirt-0.0.15-old/lib/ovirt/quota.rb rbovirt-0.0.15/lib/ovirt/quota.rb
--- rbovirt-0.0.15-old/lib/ovirt/quota.rb	1969-12-31 19:00:00.000000000 -0500
+++ rbovirt-0.0.15/lib/ovirt/quota.rb	2013-03-08 07:27:04.575999883 -0500
@@ -0,0 +1,17 @@
+module OVIRT
+class Quota < BaseObject
+    attr_reader :name, :description
+
+    def initialize(client, xml)
+      super(client, xml[:id], xml[:href], (xml/'name').first.text)
+      parse_xml_attributes!(xml)
+      self
+    end
+
+    private
+    def parse_xml_attributes!(xml)
+      @desciption = ((xml/'description').first.text rescue nil)
+    end
+  end
+end
+
diff -uNr rbovirt-0.0.15-old/lib/ovirt/vm.rb rbovirt-0.0.15/lib/ovirt/vm.rb
--- rbovirt-0.0.15-old/lib/ovirt/vm.rb	2012-12-12 17:57:36.000000000 -0500
+++ rbovirt-0.0.15/lib/ovirt/vm.rb	2013-03-08 09:50:22.034000077 -0500
@@ -5,7 +5,7 @@
 
   class VM < BaseObject
     attr_reader :description, :status, :memory, :profile, :display, :host, :cluster, :template
-    attr_reader :storage, :cores, :creation_time, :os, :ips, :vnc
+    attr_reader :storage, :cores, :creation_time, :os, :ips, :vnc, :quota
     attr_accessor :interfaces, :volumes
 
     def initialize(client, xml)
@@ -31,6 +31,10 @@
       @interfaces ||= @client.vm_interfaces(id)
     end
 
+    def quota
+      @quota ||= @client.quota(id)
+    end
+
     def volumes
       @volumes ||= @client.vm_volumes(id)
     end
@@ -53,6 +57,9 @@
           else
             template_{name_('Blank')}
           end
+          if opts[:quota]
+            quota_( :id => opts[:quota])
+          end
           if opts[:cluster]
             cluster_( :id => opts[:cluster])
           elsif opts[:cluster_name]
diff -uNr rbovirt-0.0.15-old/lib/ovirt/volume.rb rbovirt-0.0.15/lib/ovirt/volume.rb
--- rbovirt-0.0.15-old/lib/ovirt/volume.rb	2012-12-12 17:57:36.000000000 -0500
+++ rbovirt-0.0.15/lib/ovirt/volume.rb	2013-03-08 17:44:34.957000083 -0500
@@ -1,7 +1,7 @@
 module OVIRT
 
   class Volume < BaseObject
-    attr_reader :size, :disk_type, :bootable, :interface, :format, :sparse, :status, :storage_domain, :vm
+    attr_reader :size, :disk_type, :bootable, :interface, :format, :sparse, :status, :storage_domain, :vm, :quota 
 
     def initialize(client, xml)
       super(client, xml[:id], xml[:href], (xml/'name').first.text)
@@ -21,6 +21,7 @@
           interface_(opts[:interface] || 'virtio')
           format_(opts[:format] || 'cow')
           sparse_(opts[:sparse] || 'true')
+	  quota_( :id => opts[:quota])
         }
       end
       Nokogiri::XML(builder.to_xml).root.to_s
@@ -35,8 +36,9 @@
      @format = (xml/'format').first.text
      @sparse = (xml/'sparse').first.text
      @status = (xml/'status').first.text
-     @vm = Link::new(@client, (xml/'vm').first[:id], (xml/'vm').first[:href])
+     @vm = Link::new(@client, (xml/'vm').first[:id], (xml/'vm').first[:href]) rescue nil
+     @quota = ((xml/'quota').first.text rescue nil)
     end
 
   end
-end
\ No newline at end of file
+end
diff -uNr rbovirt-0.0.15-old/lib/rbovirt.rb rbovirt-0.0.15/lib/rbovirt.rb
--- rbovirt-0.0.15-old/lib/rbovirt.rb	2012-12-12 17:57:36.000000000 -0500
+++ rbovirt-0.0.15/lib/rbovirt.rb	2013-03-08 01:23:44.930000075 -0500
@@ -8,6 +8,7 @@
 require "ovirt/volume"
 require "ovirt/interface"
 require "ovirt/network"
+require "ovirt/quota"
 
 require "client/vm_api"
 require "client/template_api"
@@ -15,6 +16,7 @@
 require "client/host_api"
 require "client/datacenter_api"
 require "client/storage_domain_api"
+require "client/quota_api"
 
 require "nokogiri"
 require "rest_client"